/* engine.c generated by valac 0.42.2, the Vala compiler
 * generated from engine.vala, do not modify */

/* 
 * Copyright (C) 2011-2014 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2014 Red Hat, Inc.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <ibus.h>
#include <libkkc/libkkc.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <libutil.h>
#include <glib/gi18n-lib.h>
#include <config.h>
#include <stdio.h>
#include <gdk/gdk.h>


#define TYPE_KKC_ENGINE (kkc_engine_get_type ())
#define KKC_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KKC_ENGINE, KkcEngine))
#define KKC_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KKC_ENGINE, KkcEngineClass))
#define IS_KKC_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KKC_ENGINE))
#define IS_KKC_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KKC_ENGINE))
#define KKC_ENGINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KKC_ENGINE, KkcEngineClass))

typedef struct _KkcEngine KkcEngine;
typedef struct _KkcEngineClass KkcEngineClass;
typedef struct _KkcEnginePrivate KkcEnginePrivate;
enum  {
	KKC_ENGINE_0_PROPERTY,
	KKC_ENGINE_NUM_PROPERTIES
};
static GParamSpec* kkc_engine_properties[KKC_ENGINE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _KkcEngine {
	IBusEngine parent_instance;
	KkcEnginePrivate * priv;
};

struct _KkcEngineClass {
	IBusEngineClass parent_class;
};

struct _KkcEnginePrivate {
	KkcContext* context;
	IBusLookupTable* lookup_table;
	gboolean lookup_table_visible;
	gboolean use_custom_keymap;
	gboolean show_annotation;
	IBusKeymap* keymap;
	IBusProperty* input_mode_prop;
	IBusPropList* prop_list;
	gboolean properties_registered;
	GeeMap* input_mode_props;
	GeeMap* input_mode_symbols;
	GeeMap* name_input_modes;
	GtkClipboard* clipboard;
	guint save_dictionaries_timeout_id;
};


static gint KkcEngine_private_offset;
static gpointer kkc_engine_parent_class = NULL;
static Preferences* kkc_engine_preferences;
static Preferences* kkc_engine_preferences = NULL;
static GeeArrayList* kkc_engine_dictionaries;
static GeeArrayList* kkc_engine_dictionaries = NULL;
static KkcLanguageModel* kkc_engine_language_model;
static KkcLanguageModel* kkc_engine_language_model = NULL;
static gboolean kkc_engine_ibus;
static gboolean kkc_engine_ibus = FALSE;

GType kkc_engine_get_type (void) G_GNUC_CONST;
static void kkc_engine_set_selection_text (GtkClipboard* clipboard,
                                    const gchar* text,
                                    KkcEngine* self);
static void kkc_engine_populate_lookup_table (KkcEngine* self);
static void kkc_engine_set_lookup_table_cursor_pos (KkcEngine* self);
static void kkc_engine_update_preedit (KkcEngine* self);
static void kkc_engine_update_candidates (KkcEngine* self);
static void kkc_engine_update_input_mode (KkcEngine* self);
static void kkc_engine_reload_dictionaries (void);
static void kkc_engine_apply_preferences (KkcEngine* self);
static IBusProperty* kkc_engine_register_input_mode_property (KkcEngine* self,
                                                       KkcInputMode mode,
                                                       const gchar* name,
                                                       const gchar* label,
                                                       const gchar* symbol);
static gboolean kkc_engine_process_lookup_table_key_event (KkcEngine* self,
                                                    guint keyval,
                                                    guint keycode,
                                                    guint state);
static gboolean _vala_string_array_contains (const gchar* * stack,
                                      int stack_length,
                                      const gchar* needle);
static gboolean kkc_engine_real_process_key_event (IBusEngine* base,
                                            guint keyval,
                                            guint keycode,
                                            guint state);
static void kkc_engine_real_enable (IBusEngine* base);
static gboolean __lambda4_ (KkcEngine* self);
static gboolean ___lambda4__gsource_func (gpointer self);
static void kkc_engine_real_disable (IBusEngine* base);
static void kkc_engine_real_reset (IBusEngine* base);
static void kkc_engine_real_focus_in (IBusEngine* base);
static void kkc_engine_real_focus_out (IBusEngine* base);
static void kkc_engine_real_property_activate (IBusEngine* base,
                                        const gchar* prop_name,
                                        guint prop_state);
static void kkc_engine_real_candidate_clicked (IBusEngine* base,
                                        guint index,
                                        guint button,
                                        guint state);
static void kkc_engine_real_cursor_up (IBusEngine* base);
static void kkc_engine_real_cursor_down (IBusEngine* base);
static void kkc_engine_real_page_up (IBusEngine* base);
static void kkc_engine_real_page_down (IBusEngine* base);
gint kkc_engine_main (gchar** args,
                      int args_length1);
static void __lambda5_ (void);
static void ___lambda5__ibus_bus_disconnected (IBusBus* _sender,
                                        gpointer self);
static void __lambda6_ (const gchar* name,
                 GVariant* value);
static void ___lambda6__preferences_value_changed (Preferences* _sender,
                                            const gchar* name,
                                            GVariant* value,
                                            gpointer self);
KkcEngine* kkc_engine_new (void);
KkcEngine* kkc_engine_construct (GType object_type);
static GObject * kkc_engine_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static void _kkc_engine___lambda7_ (KkcEngine* self,
                             const gchar* name,
                             GVariant* value);
static void __kkc_engine___lambda7__preferences_value_changed (Preferences* _sender,
                                                        const gchar* name,
                                                        GVariant* value,
                                                        gpointer self);
static void _kkc_engine___lambda8_ (KkcEngine* self);
static void __kkc_engine___lambda8__g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self);
static void _kkc_engine___lambda9_ (KkcEngine* self,
                             GObject* s,
                             GParamSpec* p);
static void __kkc_engine___lambda9__g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self);
static void _kkc_engine___lambda10_ (KkcEngine* self);
static void __kkc_engine___lambda10__kkc_candidate_list_populated (KkcCandidateList* _sender,
                                                            gpointer self);
static void _kkc_engine___lambda11_ (KkcEngine* self);
static void __kkc_engine___lambda11__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self);
static void _kkc_engine___lambda12_ (KkcEngine* self);
static void __kkc_engine___lambda12__kkc_candidate_list_selected (KkcCandidateList* _sender,
                                                           KkcCandidate* candidate,
                                                           gpointer self);
static void _kkc_engine___lambda13_ (KkcEngine* self,
                              KkcContext* e);
static void __kkc_engine___lambda13__kkc_context_request_selection_text (KkcContext* _sender,
                                                                  gpointer self);
static void kkc_engine_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const gchar* KKC_ENGINE_LOOKUP_TABLE_LABELS[16] = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "a", "b", "c", "d", "e", "f"};
static const GOptionEntry KKC_ENGINE_options[2] = {{"ibus", 'i', 0, G_OPTION_ARG_NONE, &kkc_engine_ibus, N_ ("Component is executed by IBus"), NULL}, {NULL}};

static inline gpointer
kkc_engine_get_instance_private (KkcEngine* self)
{
	return G_STRUCT_MEMBER_P (self, KkcEngine_private_offset);
}


static void
kkc_engine_set_selection_text (GtkClipboard* clipboard,
                               const gchar* text,
                               KkcEngine* self)
{
	KkcContext* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (clipboard != NULL);
	_tmp0_ = self->priv->context;
	kkc_context_set_selection_text (_tmp0_, text);
}


static void
kkc_engine_populate_lookup_table (KkcEngine* self)
{
	IBusLookupTable* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->lookup_table;
	ibus_lookup_table_clear (_tmp0_);
	{
		gint i = 0;
		KkcContext* _tmp1_;
		KkcCandidateList* _tmp2_;
		KkcCandidateList* _tmp3_;
		guint _tmp4_;
		guint _tmp5_;
		_tmp1_ = self->priv->context;
		_tmp2_ = kkc_context_get_candidates (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = kkc_candidate_list_get_page_start (_tmp3_);
		_tmp5_ = _tmp4_;
		i = (gint) _tmp5_;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gint _tmp8_;
				KkcContext* _tmp9_;
				KkcCandidateList* _tmp10_;
				KkcCandidateList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				IBusText* text = NULL;
				KkcContext* _tmp14_;
				KkcCandidateList* _tmp15_;
				KkcCandidateList* _tmp16_;
				gint _tmp17_;
				KkcCandidate* _tmp18_;
				KkcCandidate* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				IBusText* _tmp22_;
				IBusText* _tmp23_;
				IBusLookupTable* _tmp24_;
				IBusText* _tmp25_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = i;
				_tmp9_ = self->priv->context;
				_tmp10_ = kkc_context_get_candidates (_tmp9_);
				_tmp11_ = _tmp10_;
				_tmp12_ = kkc_candidate_list_get_size (_tmp11_);
				_tmp13_ = _tmp12_;
				if (!(_tmp8_ < _tmp13_)) {
					break;
				}
				_tmp14_ = self->priv->context;
				_tmp15_ = kkc_context_get_candidates (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = i;
				_tmp18_ = kkc_candidate_list_get (_tmp16_, _tmp17_);
				_tmp19_ = _tmp18_;
				_tmp20_ = kkc_candidate_get_output (_tmp19_);
				_tmp21_ = _tmp20_;
				_tmp22_ = ibus_text_new_from_string (_tmp21_);
				g_object_ref_sink (_tmp22_);
				_tmp23_ = _tmp22_;
				_g_object_unref0 (_tmp19_);
				text = _tmp23_;
				_tmp24_ = self->priv->lookup_table;
				_tmp25_ = text;
				ibus_lookup_table_append_candidate (_tmp24_, _tmp25_);
				_g_object_unref0 (text);
			}
		}
	}
}


static void
kkc_engine_set_lookup_table_cursor_pos (KkcEngine* self)
{
	IBusText* empty_text = NULL;
	IBusText* _tmp0_;
	gint cursor_pos = 0;
	KkcContext* _tmp1_;
	KkcCandidateList* _tmp2_;
	KkcCandidateList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	KkcContext* _tmp6_;
	KkcCandidateList* _tmp7_;
	KkcCandidateList* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = ibus_text_new_from_static_string ("");
	g_object_ref_sink (_tmp0_);
	empty_text = _tmp0_;
	_tmp1_ = self->priv->context;
	_tmp2_ = kkc_context_get_candidates (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = kkc_candidate_list_get_cursor_pos (_tmp3_);
	_tmp5_ = _tmp4_;
	cursor_pos = _tmp5_;
	_tmp6_ = self->priv->context;
	_tmp7_ = kkc_context_get_candidates (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = kkc_candidate_list_get_page_visible (_tmp8_);
	_tmp10_ = _tmp9_;
	if (_tmp10_) {
		IBusLookupTable* _tmp11_;
		gint _tmp12_;
		KkcContext* _tmp13_;
		KkcCandidateList* _tmp14_;
		KkcCandidateList* _tmp15_;
		guint _tmp16_;
		guint _tmp17_;
		IBusLookupTable* _tmp18_;
		KkcCandidate* candidate = NULL;
		KkcContext* _tmp19_;
		KkcCandidateList* _tmp20_;
		KkcCandidateList* _tmp21_;
		KkcCandidate* _tmp22_;
		gboolean _tmp23_ = FALSE;
		gboolean _tmp24_ = FALSE;
		gboolean _tmp25_;
		_tmp11_ = self->priv->lookup_table;
		_tmp12_ = cursor_pos;
		_tmp13_ = self->priv->context;
		_tmp14_ = kkc_context_get_candidates (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = kkc_candidate_list_get_page_start (_tmp15_);
		_tmp17_ = _tmp16_;
		ibus_lookup_table_set_cursor_pos (_tmp11_, _tmp12_ - _tmp17_);
		_tmp18_ = self->priv->lookup_table;
		ibus_engine_update_lookup_table_fast ((IBusEngine*) self, _tmp18_, TRUE);
		_tmp19_ = self->priv->context;
		_tmp20_ = kkc_context_get_candidates (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = kkc_candidate_list_get (_tmp21_, -1);
		candidate = _tmp22_;
		_tmp25_ = self->priv->show_annotation;
		if (_tmp25_) {
			KkcCandidate* _tmp26_;
			const gchar* _tmp27_;
			const gchar* _tmp28_;
			_tmp26_ = candidate;
			_tmp27_ = kkc_candidate_get_annotation (_tmp26_);
			_tmp28_ = _tmp27_;
			_tmp24_ = _tmp28_ != NULL;
		} else {
			_tmp24_ = FALSE;
		}
		if (_tmp24_) {
			KkcCandidate* _tmp29_;
			const gchar* _tmp30_;
			const gchar* _tmp31_;
			_tmp29_ = candidate;
			_tmp30_ = kkc_candidate_get_annotation (_tmp29_);
			_tmp31_ = _tmp30_;
			_tmp23_ = g_strcmp0 (_tmp31_, "?") != 0;
		} else {
			_tmp23_ = FALSE;
		}
		if (_tmp23_) {
			IBusText* text = NULL;
			KkcCandidate* _tmp32_;
			const gchar* _tmp33_;
			const gchar* _tmp34_;
			IBusText* _tmp35_;
			IBusText* _tmp36_;
			_tmp32_ = candidate;
			_tmp33_ = kkc_candidate_get_annotation (_tmp32_);
			_tmp34_ = _tmp33_;
			_tmp35_ = ibus_text_new_from_string (_tmp34_);
			g_object_ref_sink (_tmp35_);
			text = _tmp35_;
			_tmp36_ = text;
			ibus_engine_update_auxiliary_text ((IBusEngine*) self, _tmp36_, TRUE);
			_g_object_unref0 (text);
		} else {
			IBusText* _tmp37_;
			_tmp37_ = empty_text;
			ibus_engine_update_auxiliary_text ((IBusEngine*) self, _tmp37_, FALSE);
		}
		self->priv->lookup_table_visible = TRUE;
		_g_object_unref0 (candidate);
	} else {
		gboolean _tmp38_;
		_tmp38_ = self->priv->lookup_table_visible;
		if (_tmp38_) {
			ibus_engine_hide_lookup_table ((IBusEngine*) self);
			ibus_engine_hide_auxiliary_text ((IBusEngine*) self);
			self->priv->lookup_table_visible = FALSE;
		}
	}
	_g_object_unref0 (empty_text);
}


static void
kkc_engine_update_preedit (KkcEngine* self)
{
	IBusText* text = NULL;
	guint cursor_pos = 0U;
	KkcContext* _tmp0_;
	KkcSegmentList* _tmp1_;
	KkcSegmentList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	IBusText* _tmp85_;
	KkcContext* _tmp88_;
	IBusText* _tmp94_;
	guint _tmp95_;
	IBusText* _tmp96_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_segments (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = kkc_segment_list_get_cursor_pos (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ >= 0) {
		KkcContext* _tmp5_;
		KkcSegmentList* _tmp6_;
		KkcSegmentList* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		IBusText* _tmp10_;
		gint index = 0;
		gint offset = 0;
		IBusText* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
		KkcContext* _tmp31_;
		KkcSegmentList* _tmp32_;
		KkcSegmentList* _tmp33_;
		gint _tmp34_;
		KkcSegment* _tmp35_;
		KkcSegment* _tmp36_;
		const gchar* _tmp37_;
		const gchar* _tmp38_;
		IBusText* _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
		KkcContext* _tmp42_;
		KkcSegmentList* _tmp43_;
		KkcSegmentList* _tmp44_;
		gint _tmp45_;
		KkcSegment* _tmp46_;
		KkcSegment* _tmp47_;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		gint _tmp50_;
		_tmp5_ = self->priv->context;
		_tmp6_ = kkc_context_get_segments (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = kkc_segment_list_get_output (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = ibus_text_new_from_string (_tmp9_);
		g_object_ref_sink (_tmp10_);
		_g_object_unref0 (text);
		text = _tmp10_;
		_g_free0 (_tmp9_);
		index = 0;
		offset = 0;
		{
			gboolean _tmp11_ = FALSE;
			_tmp11_ = TRUE;
			while (TRUE) {
				gint _tmp13_;
				KkcContext* _tmp14_;
				KkcSegmentList* _tmp15_;
				KkcSegmentList* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				KkcContext* _tmp20_;
				KkcSegmentList* _tmp21_;
				KkcSegmentList* _tmp22_;
				gint _tmp23_;
				KkcSegment* _tmp24_;
				KkcSegment* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				if (!_tmp11_) {
					gint _tmp12_;
					_tmp12_ = index;
					index = _tmp12_ + 1;
				}
				_tmp11_ = FALSE;
				_tmp13_ = index;
				_tmp14_ = self->priv->context;
				_tmp15_ = kkc_context_get_segments (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = kkc_segment_list_get_cursor_pos (_tmp16_);
				_tmp18_ = _tmp17_;
				if (!(_tmp13_ < _tmp18_)) {
					break;
				}
				_tmp19_ = offset;
				_tmp20_ = self->priv->context;
				_tmp21_ = kkc_context_get_segments (_tmp20_);
				_tmp22_ = _tmp21_;
				_tmp23_ = index;
				_tmp24_ = kkc_segment_list_get (_tmp22_, _tmp23_);
				_tmp25_ = _tmp24_;
				_tmp26_ = kkc_segment_get_output (_tmp25_);
				_tmp27_ = _tmp26_;
				offset = _tmp19_ + g_utf8_strlen (_tmp27_, (gssize) -1);
				_g_object_unref0 (_tmp25_);
			}
		}
		_tmp28_ = text;
		_tmp29_ = offset;
		_tmp30_ = offset;
		_tmp31_ = self->priv->context;
		_tmp32_ = kkc_context_get_segments (_tmp31_);
		_tmp33_ = _tmp32_;
		_tmp34_ = index;
		_tmp35_ = kkc_segment_list_get (_tmp33_, _tmp34_);
		_tmp36_ = _tmp35_;
		_tmp37_ = kkc_segment_get_output (_tmp36_);
		_tmp38_ = _tmp37_;
		ibus_text_append_attribute (_tmp28_, (guint) IBUS_ATTR_TYPE_BACKGROUND, (guint) 0x00c8c8f0, (guint) _tmp29_, _tmp30_ + g_utf8_strlen (_tmp38_, (gssize) -1));
		_g_object_unref0 (_tmp36_);
		_tmp39_ = text;
		_tmp40_ = offset;
		_tmp41_ = offset;
		_tmp42_ = self->priv->context;
		_tmp43_ = kkc_context_get_segments (_tmp42_);
		_tmp44_ = _tmp43_;
		_tmp45_ = index;
		_tmp46_ = kkc_segment_list_get (_tmp44_, _tmp45_);
		_tmp47_ = _tmp46_;
		_tmp48_ = kkc_segment_get_output (_tmp47_);
		_tmp49_ = _tmp48_;
		ibus_text_append_attribute (_tmp39_, (guint) IBUS_ATTR_TYPE_FOREGROUND, (guint) 0x00000000, (guint) _tmp40_, _tmp41_ + g_utf8_strlen (_tmp49_, (gssize) -1));
		_g_object_unref0 (_tmp47_);
		_tmp50_ = offset;
		cursor_pos = (guint) _tmp50_;
	} else {
		KkcContext* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		IBusText* _tmp55_;
		gboolean _tmp56_ = FALSE;
		IBusText* _tmp57_;
		_tmp51_ = self->priv->context;
		_tmp52_ = kkc_context_get_input (_tmp51_);
		_tmp53_ = _tmp52_;
		_tmp54_ = _tmp53_;
		_tmp55_ = ibus_text_new_from_string (_tmp54_);
		g_object_ref_sink (_tmp55_);
		_g_object_unref0 (text);
		text = _tmp55_;
		_g_free0 (_tmp54_);
		_tmp57_ = text;
		if (ibus_text_get_length (_tmp57_) > ((guint) 0)) {
			KkcContext* _tmp58_;
			gint _tmp59_;
			gint _tmp60_;
			_tmp58_ = self->priv->context;
			_tmp59_ = kkc_context_get_input_cursor_pos (_tmp58_);
			_tmp60_ = _tmp59_;
			_tmp56_ = _tmp60_ >= 0;
		} else {
			_tmp56_ = FALSE;
		}
		if (_tmp56_) {
			IBusText* _tmp61_;
			KkcContext* _tmp62_;
			gint _tmp63_;
			gint _tmp64_;
			KkcContext* _tmp65_;
			gint _tmp66_;
			gint _tmp67_;
			KkcContext* _tmp68_;
			guint _tmp69_;
			guint _tmp70_;
			IBusText* _tmp71_;
			KkcContext* _tmp72_;
			gint _tmp73_;
			gint _tmp74_;
			KkcContext* _tmp75_;
			gint _tmp76_;
			gint _tmp77_;
			KkcContext* _tmp78_;
			guint _tmp79_;
			guint _tmp80_;
			KkcContext* _tmp81_;
			gint _tmp82_;
			gint _tmp83_;
			_tmp61_ = text;
			_tmp62_ = self->priv->context;
			_tmp63_ = kkc_context_get_input_cursor_pos (_tmp62_);
			_tmp64_ = _tmp63_;
			_tmp65_ = self->priv->context;
			_tmp66_ = kkc_context_get_input_cursor_pos (_tmp65_);
			_tmp67_ = _tmp66_;
			_tmp68_ = self->priv->context;
			_tmp69_ = kkc_context_get_input_cursor_width (_tmp68_);
			_tmp70_ = _tmp69_;
			ibus_text_append_attribute (_tmp61_, (guint) IBUS_ATTR_TYPE_BACKGROUND, (guint) 0x00000000, (guint) _tmp64_, _tmp67_ + ((gint) _tmp70_));
			_tmp71_ = text;
			_tmp72_ = self->priv->context;
			_tmp73_ = kkc_context_get_input_cursor_pos (_tmp72_);
			_tmp74_ = _tmp73_;
			_tmp75_ = self->priv->context;
			_tmp76_ = kkc_context_get_input_cursor_pos (_tmp75_);
			_tmp77_ = _tmp76_;
			_tmp78_ = self->priv->context;
			_tmp79_ = kkc_context_get_input_cursor_width (_tmp78_);
			_tmp80_ = _tmp79_;
			ibus_text_append_attribute (_tmp71_, (guint) IBUS_ATTR_TYPE_FOREGROUND, (guint) 0xffffffffLL, (guint) _tmp74_, _tmp77_ + ((gint) _tmp80_));
			_tmp81_ = self->priv->context;
			_tmp82_ = kkc_context_get_input_cursor_pos (_tmp81_);
			_tmp83_ = _tmp82_;
			cursor_pos = (guint) _tmp83_;
		} else {
			IBusText* _tmp84_;
			_tmp84_ = text;
			cursor_pos = ibus_text_get_length (_tmp84_);
		}
	}
	_tmp85_ = text;
	if (ibus_text_get_length (_tmp85_) > ((guint) 0)) {
		IBusText* _tmp86_;
		IBusText* _tmp87_;
		_tmp86_ = text;
		_tmp87_ = text;
		ibus_text_append_attribute (_tmp86_, (guint) IBUS_ATTR_TYPE_UNDERLINE, (guint) IBUS_ATTR_UNDERLINE_SINGLE, (guint) 0, (gint) ibus_text_get_length (_tmp87_));
	}
	_tmp88_ = self->priv->context;
	if (kkc_context_has_output (_tmp88_)) {
		gchar* output = NULL;
		KkcContext* _tmp89_;
		gchar* _tmp90_;
		IBusText* ctext = NULL;
		const gchar* _tmp91_;
		IBusText* _tmp92_;
		IBusText* _tmp93_;
		_tmp89_ = self->priv->context;
		_tmp90_ = kkc_context_poll_output (_tmp89_);
		output = _tmp90_;
		_tmp91_ = output;
		_tmp92_ = ibus_text_new_from_string (_tmp91_);
		g_object_ref_sink (_tmp92_);
		ctext = _tmp92_;
		_tmp93_ = ctext;
		ibus_engine_commit_text ((IBusEngine*) self, _tmp93_);
		_g_object_unref0 (ctext);
		_g_free0 (output);
	}
	_tmp94_ = text;
	_tmp95_ = cursor_pos;
	_tmp96_ = text;
	ibus_engine_update_preedit_text ((IBusEngine*) self, _tmp94_, _tmp95_, ibus_text_get_length (_tmp96_) > ((guint) 0));
	_g_object_unref0 (text);
}


static void
kkc_engine_update_candidates (KkcEngine* self)
{
	g_return_if_fail (self != NULL);
	kkc_engine_populate_lookup_table (self);
	kkc_engine_set_lookup_table_cursor_pos (self);
}


static void
kkc_engine_update_input_mode (KkcEngine* self)
{
	gboolean changed = FALSE;
	GeeMapIterator* iter = NULL;
	GeeMap* _tmp0_;
	GeeMapIterator* _tmp1_;
	IBusText* symbol = NULL;
	GeeMap* _tmp19_;
	KkcContext* _tmp20_;
	KkcInputMode _tmp21_;
	KkcInputMode _tmp22_;
	gpointer _tmp23_;
	gchar* _tmp24_;
	IBusText* _tmp25_;
	IBusText* _tmp26_;
	IBusText* label = NULL;
	IBusText* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	IBusText* _tmp31_;
	IBusText* _tmp32_;
	IBusProperty* _tmp33_;
	IBusText* _tmp34_;
	IBusText* _tmp35_;
	IBusProperty* _tmp38_;
	IBusText* _tmp39_;
	IBusText* _tmp40_;
	gboolean _tmp43_ = FALSE;
	gboolean _tmp44_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->input_mode_props;
	_tmp1_ = gee_map_map_iterator (_tmp0_);
	iter = _tmp1_;
	while (TRUE) {
		GeeMapIterator* _tmp2_;
		KkcInputMode input_mode = 0;
		GeeMapIterator* _tmp3_;
		gpointer _tmp4_;
		IBusProperty* prop = NULL;
		GeeMapIterator* _tmp5_;
		gpointer _tmp6_;
		KkcInputMode _tmp7_;
		KkcContext* _tmp8_;
		KkcInputMode _tmp9_;
		KkcInputMode _tmp10_;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_;
		_tmp2_ = iter;
		if (!gee_map_iterator_next (_tmp2_)) {
			break;
		}
		_tmp3_ = iter;
		_tmp4_ = gee_map_iterator_get_key (_tmp3_);
		input_mode = (KkcInputMode) ((gintptr) _tmp4_);
		_tmp5_ = iter;
		_tmp6_ = gee_map_iterator_get_value (_tmp5_);
		prop = (IBusProperty*) _tmp6_;
		changed = FALSE;
		_tmp7_ = input_mode;
		_tmp8_ = self->priv->context;
		_tmp9_ = kkc_context_get_input_mode (_tmp8_);
		_tmp10_ = _tmp9_;
		if (_tmp7_ == _tmp10_) {
			IBusProperty* _tmp11_;
			_tmp11_ = prop;
			if (ibus_property_get_state (_tmp11_) == PROP_STATE_UNCHECKED) {
				IBusProperty* _tmp12_;
				_tmp12_ = prop;
				ibus_property_set_state (_tmp12_, PROP_STATE_CHECKED);
				changed = TRUE;
			}
		} else {
			IBusProperty* _tmp13_;
			_tmp13_ = prop;
			if (ibus_property_get_state (_tmp13_) == PROP_STATE_CHECKED) {
				IBusProperty* _tmp14_;
				_tmp14_ = prop;
				ibus_property_set_state (_tmp14_, PROP_STATE_UNCHECKED);
				changed = TRUE;
			}
		}
		_tmp16_ = changed;
		if (_tmp16_) {
			gboolean _tmp17_;
			_tmp17_ = self->priv->properties_registered;
			_tmp15_ = _tmp17_;
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			IBusProperty* _tmp18_;
			_tmp18_ = prop;
			ibus_engine_update_property ((IBusEngine*) self, _tmp18_);
		}
		_g_object_unref0 (prop);
	}
	changed = FALSE;
	_tmp19_ = self->priv->input_mode_symbols;
	_tmp20_ = self->priv->context;
	_tmp21_ = kkc_context_get_input_mode (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = gee_map_get (_tmp19_, (gpointer) ((gintptr) _tmp22_));
	_tmp24_ = (gchar*) _tmp23_;
	_tmp25_ = ibus_text_new_from_string (_tmp24_);
	g_object_ref_sink (_tmp25_);
	_tmp26_ = _tmp25_;
	_g_free0 (_tmp24_);
	symbol = _tmp26_;
	_tmp27_ = symbol;
	_tmp28_ = _tmp27_->text;
	_tmp29_ = g_strdup_printf (_ ("Input Mode (%s)"), _tmp28_);
	_tmp30_ = _tmp29_;
	_tmp31_ = ibus_text_new_from_string (_tmp30_);
	g_object_ref_sink (_tmp31_);
	_tmp32_ = _tmp31_;
	_g_free0 (_tmp30_);
	label = _tmp32_;
	_tmp33_ = self->priv->input_mode_prop;
	_tmp34_ = ibus_property_get_symbol (_tmp33_);
	_tmp35_ = symbol;
	if (_tmp34_ != _tmp35_) {
		IBusProperty* _tmp36_;
		IBusText* _tmp37_;
		_tmp36_ = self->priv->input_mode_prop;
		_tmp37_ = symbol;
		ibus_property_set_symbol (_tmp36_, _tmp37_);
		changed = TRUE;
	}
	_tmp38_ = self->priv->input_mode_prop;
	_tmp39_ = ibus_property_get_label (_tmp38_);
	_tmp40_ = label;
	if (_tmp39_ != _tmp40_) {
		IBusProperty* _tmp41_;
		IBusText* _tmp42_;
		_tmp41_ = self->priv->input_mode_prop;
		_tmp42_ = label;
		ibus_property_set_label (_tmp41_, _tmp42_);
		changed = TRUE;
	}
	_tmp44_ = changed;
	if (_tmp44_) {
		gboolean _tmp45_;
		_tmp45_ = self->priv->properties_registered;
		_tmp43_ = _tmp45_;
	} else {
		_tmp43_ = FALSE;
	}
	if (_tmp43_) {
		IBusProperty* _tmp46_;
		_tmp46_ = self->priv->input_mode_prop;
		ibus_engine_update_property ((IBusEngine*) self, _tmp46_);
	}
	_g_object_unref0 (label);
	_g_object_unref0 (symbol);
	_g_object_unref0 (iter);
}


static void
kkc_engine_reload_dictionaries (void)
{
	GeeArrayList* _tmp0_;
	GVariant* variant = NULL;
	Preferences* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	Preferences* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	gchar** strv = NULL;
	GVariant* _tmp16_;
	size_t _tmp17_;
	gchar** _tmp18_;
	gint strv_length1;
	gint _strv_size_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	GError * _inner_error_ = NULL;
	_tmp0_ = kkc_engine_dictionaries;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	_tmp1_ = kkc_engine_preferences;
	_tmp2_ = preferences_get (_tmp1_, "user_dictionary");
	_g_variant_unref0 (variant);
	variant = _tmp2_;
	_tmp3_ = variant;
	if (_tmp3_ != NULL) {
		{
			KkcUserDictionary* _tmp4_ = NULL;
			GVariant* _tmp5_;
			const gchar* _tmp6_;
			KkcUserDictionary* _tmp7_;
			GeeArrayList* _tmp8_;
			_tmp5_ = variant;
			_tmp6_ = g_variant_get_string (_tmp5_, NULL);
			_tmp7_ = kkc_user_dictionary_new (_tmp6_, &_inner_error_);
			_tmp4_ = _tmp7_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp8_ = kkc_engine_dictionaries;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, (KkcDictionary*) _tmp4_);
			_g_object_unref0 (_tmp4_);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GVariant* _tmp9_;
			const gchar* _tmp10_;
			GError* _tmp11_;
			const gchar* _tmp12_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp9_ = variant;
			_tmp10_ = g_variant_get_string (_tmp9_, NULL);
			_tmp11_ = e;
			_tmp12_ = _tmp11_->message;
			g_warning ("engine.vala:339: can't load user dictionary %s: %s", _tmp10_, _tmp12_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_variant_unref0 (variant);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp13_ = kkc_engine_preferences;
	_tmp14_ = preferences_get (_tmp13_, "system_dictionaries");
	_g_variant_unref0 (variant);
	variant = _tmp14_;
	_tmp15_ = variant;
	_vala_assert (_tmp15_ != NULL, "variant != null");
	_tmp16_ = variant;
	_tmp18_ = g_variant_dup_strv (_tmp16_, &_tmp17_);
	strv = _tmp18_;
	strv_length1 = _tmp17_;
	_strv_size_ = strv_length1;
	_tmp19_ = strv;
	_tmp19__length1 = strv_length1;
	{
		gchar** id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
		id_collection = _tmp19_;
		id_collection_length1 = _tmp19__length1;
		for (id_it = 0; id_it < _tmp19__length1; id_it = id_it + 1) {
			gchar* _tmp20_;
			gchar* id = NULL;
			_tmp20_ = g_strdup (id_collection[id_it]);
			id = _tmp20_;
			{
				DictionaryMetadata* metadata = NULL;
				Preferences* _tmp21_;
				const gchar* _tmp22_;
				DictionaryMetadata* _tmp23_;
				_tmp21_ = kkc_engine_preferences;
				_tmp22_ = id;
				_tmp23_ = preferences_get_dictionary_metadata (_tmp21_, _tmp22_);
				metadata = _tmp23_;
				{
					KkcSystemSegmentDictionary* _tmp24_ = NULL;
					DictionaryMetadata* _tmp25_;
					const gchar* _tmp26_;
					const gchar* _tmp27_;
					DictionaryMetadata* _tmp28_;
					const gchar* _tmp29_;
					const gchar* _tmp30_;
					KkcSystemSegmentDictionary* _tmp31_;
					GeeArrayList* _tmp32_;
					_tmp25_ = metadata;
					_tmp26_ = dictionary_metadata_get_filename (_tmp25_);
					_tmp27_ = _tmp26_;
					_tmp28_ = metadata;
					_tmp29_ = dictionary_metadata_get_encoding (_tmp28_);
					_tmp30_ = _tmp29_;
					_tmp31_ = kkc_system_segment_dictionary_new (_tmp27_, _tmp30_, &_inner_error_);
					_tmp24_ = _tmp31_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						goto __catch1_g_error;
					}
					_tmp32_ = kkc_engine_dictionaries;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, (KkcDictionary*) _tmp24_);
					_g_object_unref0 (_tmp24_);
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					DictionaryMetadata* _tmp33_;
					const gchar* _tmp34_;
					const gchar* _tmp35_;
					GError* _tmp36_;
					const gchar* _tmp37_;
					e = _inner_error_;
					_inner_error_ = NULL;
					_tmp33_ = metadata;
					_tmp34_ = dictionary_metadata_get_filename (_tmp33_);
					_tmp35_ = _tmp34_;
					_tmp36_ = e;
					_tmp37_ = _tmp36_->message;
					g_warning ("engine.vala:355: can't load system dictionary %s: %s", _tmp35_, _tmp37_);
					_g_error_free0 (e);
				}
				__finally1:
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_object_unref0 (metadata);
					_g_free0 (id);
					strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
					_g_variant_unref0 (variant);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				_g_object_unref0 (metadata);
				_g_free0 (id);
			}
		}
	}
	strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
	_g_variant_unref0 (variant);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
kkc_engine_apply_preferences (KkcEngine* self)
{
	GVariant* variant = NULL;
	Preferences* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	KkcContext* _tmp3_;
	GVariant* _tmp4_;
	Preferences* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	KkcContext* _tmp8_;
	GVariant* _tmp9_;
	Preferences* _tmp10_;
	GVariant* _tmp11_;
	GVariant* _tmp12_;
	KkcContext* _tmp13_;
	KkcCandidateList* _tmp14_;
	KkcCandidateList* _tmp15_;
	GVariant* _tmp16_;
	IBusLookupTable* _tmp17_;
	GVariant* _tmp18_;
	Preferences* _tmp19_;
	GVariant* _tmp20_;
	GVariant* _tmp21_;
	KkcContext* _tmp22_;
	KkcCandidateList* _tmp23_;
	KkcCandidateList* _tmp24_;
	GVariant* _tmp25_;
	Preferences* _tmp26_;
	GVariant* _tmp27_;
	GVariant* _tmp28_;
	KkcContext* _tmp29_;
	GVariant* _tmp30_;
	Preferences* _tmp31_;
	GVariant* _tmp32_;
	GVariant* _tmp33_;
	GVariant* _tmp34_;
	Preferences* _tmp35_;
	GVariant* _tmp36_;
	GVariant* _tmp37_;
	KkcRuleMetadata* parent_metadata = NULL;
	GVariant* _tmp38_;
	const gchar* _tmp39_;
	KkcRuleMetadata* _tmp40_;
	gchar* base_dir = NULL;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	Preferences* _tmp50_;
	GVariant* _tmp51_;
	GVariant* _tmp52_;
	GVariant* _tmp53_;
	Preferences* _tmp54_;
	GVariant* _tmp55_;
	GVariant* _tmp56_;
	GVariant* _tmp57_;
	const gchar* _tmp58_;
	IBusKeymap* _tmp59_;
	IBusKeymap* _tmp60_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = kkc_engine_preferences;
	_tmp1_ = preferences_get (_tmp0_, "punctuation_style");
	_g_variant_unref0 (variant);
	variant = _tmp1_;
	_tmp2_ = variant;
	_vala_assert (_tmp2_ != NULL, "variant != null");
	_tmp3_ = self->priv->context;
	_tmp4_ = variant;
	kkc_context_set_punctuation_style (_tmp3_, (KkcPunctuationStyle) g_variant_get_int32 (_tmp4_));
	_tmp5_ = kkc_engine_preferences;
	_tmp6_ = preferences_get (_tmp5_, "auto_correct");
	_g_variant_unref0 (variant);
	variant = _tmp6_;
	_tmp7_ = variant;
	_vala_assert (_tmp7_ != NULL, "variant != null");
	_tmp8_ = self->priv->context;
	_tmp9_ = variant;
	kkc_context_set_auto_correct (_tmp8_, g_variant_get_boolean (_tmp9_));
	_tmp10_ = kkc_engine_preferences;
	_tmp11_ = preferences_get (_tmp10_, "page_size");
	_g_variant_unref0 (variant);
	variant = _tmp11_;
	_tmp12_ = variant;
	_vala_assert (_tmp12_ != NULL, "variant != null");
	_tmp13_ = self->priv->context;
	_tmp14_ = kkc_context_get_candidates (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = variant;
	kkc_candidate_list_set_page_size (_tmp15_, (guint) g_variant_get_int32 (_tmp16_));
	_tmp17_ = self->priv->lookup_table;
	_tmp18_ = variant;
	ibus_lookup_table_set_page_size (_tmp17_, (guint) g_variant_get_int32 (_tmp18_));
	_tmp19_ = kkc_engine_preferences;
	_tmp20_ = preferences_get (_tmp19_, "pagination_start");
	_g_variant_unref0 (variant);
	variant = _tmp20_;
	_tmp21_ = variant;
	_vala_assert (_tmp21_ != NULL, "variant != null");
	_tmp22_ = self->priv->context;
	_tmp23_ = kkc_context_get_candidates (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = variant;
	kkc_candidate_list_set_page_start (_tmp24_, (guint) g_variant_get_int32 (_tmp25_));
	_tmp26_ = kkc_engine_preferences;
	_tmp27_ = preferences_get (_tmp26_, "initial_input_mode");
	_g_variant_unref0 (variant);
	variant = _tmp27_;
	_tmp28_ = variant;
	_vala_assert (_tmp28_ != NULL, "variant != null");
	_tmp29_ = self->priv->context;
	_tmp30_ = variant;
	kkc_context_set_input_mode (_tmp29_, (KkcInputMode) g_variant_get_int32 (_tmp30_));
	_tmp31_ = kkc_engine_preferences;
	_tmp32_ = preferences_get (_tmp31_, "show_annotation");
	_g_variant_unref0 (variant);
	variant = _tmp32_;
	_tmp33_ = variant;
	_vala_assert (_tmp33_ != NULL, "variant != null");
	_tmp34_ = variant;
	self->priv->show_annotation = g_variant_get_boolean (_tmp34_);
	_tmp35_ = kkc_engine_preferences;
	_tmp36_ = preferences_get (_tmp35_, "typing_rule");
	_g_variant_unref0 (variant);
	variant = _tmp36_;
	_tmp37_ = variant;
	_vala_assert (_tmp37_ != NULL, "variant != null");
	_tmp38_ = variant;
	_tmp39_ = g_variant_get_string (_tmp38_, NULL);
	_tmp40_ = kkc_rule_metadata_find (_tmp39_);
	parent_metadata = _tmp40_;
	_vala_assert (parent_metadata != NULL, "parent_metadata != null");
	_tmp41_ = g_get_user_config_dir ();
	_tmp42_ = g_build_filename (_tmp41_, "ibus-kkc", "rules", NULL);
	base_dir = _tmp42_;
	{
		KkcUserRule* _tmp43_ = NULL;
		KkcUserRule* _tmp44_;
		KkcContext* _tmp45_;
		_tmp44_ = kkc_user_rule_new (parent_metadata, base_dir, "ibus-kkc", &_inner_error_);
		_tmp43_ = _tmp44_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch2_g_error;
		}
		_tmp45_ = self->priv->context;
		kkc_context_set_typing_rule (_tmp45_, (KkcRule*) _tmp43_);
		_g_object_unref0 (_tmp43_);
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GVariant* _tmp46_;
		const gchar* _tmp47_;
		GError* _tmp48_;
		const gchar* _tmp49_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp46_ = variant;
		_tmp47_ = g_variant_get_string (_tmp46_, NULL);
		_tmp48_ = e;
		_tmp49_ = _tmp48_->message;
		g_warning ("engine.vala:405: can't load typing rule %s: %s", _tmp47_, _tmp49_);
		_g_error_free0 (e);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (base_dir);
		_g_object_unref0 (parent_metadata);
		_g_variant_unref0 (variant);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp50_ = kkc_engine_preferences;
	_tmp51_ = preferences_get (_tmp50_, "use_custom_keymap");
	_g_variant_unref0 (variant);
	variant = _tmp51_;
	_tmp52_ = variant;
	_vala_assert (_tmp52_ != NULL, "variant != null");
	_tmp53_ = variant;
	self->priv->use_custom_keymap = g_variant_get_boolean (_tmp53_);
	_tmp54_ = kkc_engine_preferences;
	_tmp55_ = preferences_get (_tmp54_, "keymap");
	_g_variant_unref0 (variant);
	variant = _tmp55_;
	_tmp56_ = variant;
	_vala_assert (_tmp56_ != NULL, "variant != null");
	_tmp57_ = variant;
	_tmp58_ = g_variant_get_string (_tmp57_, NULL);
	_tmp59_ = ibus_keymap_get (_tmp58_);
	_tmp60_ = _g_object_ref0 (_tmp59_);
	_g_object_unref0 (self->priv->keymap);
	self->priv->keymap = _tmp60_;
	_g_free0 (base_dir);
	_g_object_unref0 (parent_metadata);
	_g_variant_unref0 (variant);
}


static IBusProperty*
kkc_engine_register_input_mode_property (KkcEngine* self,
                                         KkcInputMode mode,
                                         const gchar* name,
                                         const gchar* label,
                                         const gchar* symbol)
{
	IBusProperty* result = NULL;
	IBusProperty* prop = NULL;
	IBusText* _tmp0_;
	IBusText* _tmp1_;
	IBusProperty* _tmp2_;
	IBusProperty* _tmp3_;
	GeeMap* _tmp4_;
	GeeMap* _tmp5_;
	GeeMap* _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (label != NULL, NULL);
	g_return_val_if_fail (symbol != NULL, NULL);
	_tmp0_ = ibus_text_new_from_string (label);
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = ibus_property_new (name, PROP_TYPE_RADIO, _tmp1_, NULL, NULL, TRUE, TRUE, PROP_STATE_UNCHECKED, NULL);
	g_object_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	prop = _tmp3_;
	_tmp4_ = self->priv->input_mode_props;
	gee_map_set (_tmp4_, (gpointer) ((gintptr) mode), prop);
	_tmp5_ = self->priv->input_mode_symbols;
	gee_map_set (_tmp5_, (gpointer) ((gintptr) mode), symbol);
	_tmp6_ = self->priv->name_input_modes;
	gee_map_set (_tmp6_, name, (gpointer) ((gintptr) mode));
	result = prop;
	return result;
}


static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* result = NULL;
	gchar* str = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	_tmp0_ = g_new0 (gchar, 7);
	str = (gchar*) _tmp0_;
	_tmp1_ = str;
	g_unichar_to_utf8 (self, _tmp1_);
	result = str;
	return result;
}


static gboolean
_vala_string_array_contains (const gchar* * stack,
                             int stack_length,
                             const gchar* needle)
{
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


static gboolean
kkc_engine_process_lookup_table_key_event (KkcEngine* self,
                                           guint keyval,
                                           guint keycode,
                                           guint state)
{
	gboolean result = FALSE;
	guint page_size = 0U;
	IBusLookupTable* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->lookup_table;
	page_size = ibus_lookup_table_get_page_size (_tmp0_);
	if (state == ((guint) 0)) {
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = g_unichar_to_string ((gunichar) keyval);
		_tmp3_ = _tmp2_;
		_tmp1_ = _vala_string_array_contains (KKC_ENGINE_LOOKUP_TABLE_LABELS, G_N_ELEMENTS (KKC_ENGINE_LOOKUP_TABLE_LABELS), _tmp3_);
		_g_free0 (_tmp3_);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gchar* label = NULL;
		gchar* _tmp4_;
		_tmp4_ = g_unichar_to_string (g_unichar_tolower ((gunichar) keyval));
		label = _tmp4_;
		{
			gint index = 0;
			index = 0;
			{
				gboolean _tmp5_ = FALSE;
				_tmp5_ = TRUE;
				while (TRUE) {
					gint _tmp7_;
					guint _tmp8_;
					gint _tmp9_;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					if (!_tmp5_) {
						gint _tmp6_;
						_tmp6_ = index;
						index = _tmp6_ + 1;
					}
					_tmp5_ = FALSE;
					_tmp7_ = index;
					_tmp8_ = page_size;
					if (!(_tmp7_ < MIN ((gint) _tmp8_, G_N_ELEMENTS (KKC_ENGINE_LOOKUP_TABLE_LABELS)))) {
						break;
					}
					_tmp9_ = index;
					_tmp10_ = KKC_ENGINE_LOOKUP_TABLE_LABELS[_tmp9_];
					_tmp11_ = label;
					if (g_strcmp0 (_tmp10_, _tmp11_) == 0) {
						KkcContext* _tmp12_;
						KkcCandidateList* _tmp13_;
						KkcCandidateList* _tmp14_;
						gint _tmp15_;
						_tmp12_ = self->priv->context;
						_tmp13_ = kkc_context_get_candidates (_tmp12_);
						_tmp14_ = _tmp13_;
						_tmp15_ = index;
						result = kkc_candidate_list_select_at (_tmp14_, (guint) _tmp15_);
						_g_free0 (label);
						return result;
					}
				}
			}
		}
		result = FALSE;
		_g_free0 (label);
		return result;
	}
	if (state == ((guint) 0)) {
		gboolean retval = FALSE;
		gboolean _tmp28_;
		retval = FALSE;
		switch (keyval) {
			case IBUS_Page_Up:
			case IBUS_KP_Page_Up:
			{
				KkcContext* _tmp16_;
				KkcCandidateList* _tmp17_;
				KkcCandidateList* _tmp18_;
				_tmp16_ = self->priv->context;
				_tmp17_ = kkc_context_get_candidates (_tmp16_);
				_tmp18_ = _tmp17_;
				retval = kkc_candidate_list_page_up (_tmp18_);
				break;
			}
			case IBUS_Page_Down:
			case IBUS_KP_Page_Down:
			{
				KkcContext* _tmp19_;
				KkcCandidateList* _tmp20_;
				KkcCandidateList* _tmp21_;
				_tmp19_ = self->priv->context;
				_tmp20_ = kkc_context_get_candidates (_tmp19_);
				_tmp21_ = _tmp20_;
				retval = kkc_candidate_list_page_down (_tmp21_);
				break;
			}
			case IBUS_Up:
			{
				KkcContext* _tmp22_;
				KkcCandidateList* _tmp23_;
				KkcCandidateList* _tmp24_;
				_tmp22_ = self->priv->context;
				_tmp23_ = kkc_context_get_candidates (_tmp22_);
				_tmp24_ = _tmp23_;
				retval = kkc_candidate_list_cursor_up (_tmp24_);
				break;
			}
			case IBUS_Down:
			{
				KkcContext* _tmp25_;
				KkcCandidateList* _tmp26_;
				KkcCandidateList* _tmp27_;
				_tmp25_ = self->priv->context;
				_tmp26_ = kkc_context_get_candidates (_tmp25_);
				_tmp27_ = _tmp26_;
				retval = kkc_candidate_list_cursor_down (_tmp27_);
				break;
			}
			default:
			{
				result = FALSE;
				return result;
			}
		}
		_tmp28_ = retval;
		if (_tmp28_) {
			kkc_engine_set_lookup_table_cursor_pos (self);
			kkc_engine_update_preedit (self);
		}
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static gboolean
kkc_engine_real_process_key_event (IBusEngine* base,
                                   guint keyval,
                                   guint keycode,
                                   guint state)
{
	KkcEngine * self;
	gboolean result = FALSE;
	guint _keyval = 0U;
	gboolean _tmp0_;
	guint _state = 0U;
	gboolean _tmp2_ = FALSE;
	KkcContext* _tmp3_;
	KkcCandidateList* _tmp4_;
	KkcCandidateList* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	KkcKeyEvent* key = NULL;
	guint _tmp10_;
	guint _tmp11_;
	KkcKeyEvent* _tmp12_;
	gboolean retval = FALSE;
	KkcContext* _tmp13_;
	KkcKeyEvent* _tmp14_;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_;
	self = (KkcEngine*) base;
	_keyval = keyval;
	_tmp0_ = self->priv->use_custom_keymap;
	if (_tmp0_) {
		IBusKeymap* _tmp1_;
		_tmp1_ = self->priv->keymap;
		_keyval = ibus_keymap_lookup_keysym (_tmp1_, (guint16) keycode, (guint32) state);
	}
	_state = state & ((((IBUS_SHIFT_MASK | IBUS_CONTROL_MASK) | IBUS_MOD1_MASK) | IBUS_MOD5_MASK) | IBUS_RELEASE_MASK);
	_tmp3_ = self->priv->context;
	_tmp4_ = kkc_context_get_candidates (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = kkc_candidate_list_get_page_visible (_tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp7_) {
		guint _tmp8_;
		guint _tmp9_;
		_tmp8_ = _keyval;
		_tmp9_ = _state;
		_tmp2_ = kkc_engine_process_lookup_table_key_event (self, _tmp8_, keycode, _tmp9_);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		result = TRUE;
		return result;
	}
	_tmp10_ = _keyval;
	_tmp11_ = _state;
	_tmp12_ = kkc_key_event_new_from_x_event (_tmp10_, keycode, (KkcModifierType) _tmp11_);
	key = _tmp12_;
	_tmp13_ = self->priv->context;
	_tmp14_ = key;
	retval = kkc_context_process_key_event (_tmp13_, _tmp14_);
	_tmp20_ = retval;
	if (!_tmp20_) {
		gboolean _tmp21_;
		_tmp21_ = self->priv->use_custom_keymap;
		_tmp19_ = _tmp21_;
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		guint _tmp22_;
		_tmp22_ = _keyval;
		_tmp18_ = _tmp22_ != keyval;
	} else {
		_tmp18_ = FALSE;
	}
	if (_tmp18_) {
		guint _tmp23_;
		_tmp23_ = _keyval;
		_tmp17_ = ((guint) 0x20) <= _tmp23_;
	} else {
		_tmp17_ = FALSE;
	}
	if (_tmp17_) {
		guint _tmp24_;
		_tmp24_ = _keyval;
		_tmp16_ = _tmp24_ <= ((guint) 0x7F);
	} else {
		_tmp16_ = FALSE;
	}
	if (_tmp16_) {
		_tmp15_ = (state & IBUS_RELEASE_MASK) == ((guint) 0);
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		GString* builder = NULL;
		GString* _tmp25_;
		GString* _tmp26_;
		guint _tmp27_;
		IBusText* text = NULL;
		GString* _tmp28_;
		const gchar* _tmp29_;
		IBusText* _tmp30_;
		IBusText* _tmp31_;
		_tmp25_ = g_string_new ("");
		builder = _tmp25_;
		_tmp26_ = builder;
		_tmp27_ = _keyval;
		g_string_append_c (_tmp26_, (gchar) _tmp27_);
		_tmp28_ = builder;
		_tmp29_ = _tmp28_->str;
		_tmp30_ = ibus_text_new_from_string (_tmp29_);
		g_object_ref_sink (_tmp30_);
		text = _tmp30_;
		_tmp31_ = text;
		ibus_engine_commit_text ((IBusEngine*) self, _tmp31_);
		result = TRUE;
		_g_object_unref0 (text);
		_g_string_free0 (builder);
		_g_object_unref0 (key);
		return result;
	}
	result = retval;
	_g_object_unref0 (key);
	return result;
}


static gboolean
__lambda4_ (KkcEngine* self)
{
	gboolean result = FALSE;
	KkcContext* _tmp0_;
	KkcDictionaryList* _tmp1_;
	KkcDictionaryList* _tmp2_;
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_dictionaries (_tmp0_);
	_tmp2_ = _tmp1_;
	kkc_dictionary_list_save (_tmp2_);
	result = TRUE;
	return result;
}


static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ ((KkcEngine*) self);
	return result;
}


static void
kkc_engine_real_enable (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	kkc_context_reset (_tmp0_);
	self->priv->save_dictionaries_timeout_id = g_timeout_add_seconds_full (G_PRIORITY_LOW, (guint) 300, ___lambda4__gsource_func, g_object_ref (self), g_object_unref);
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->enable (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
}


static void
kkc_engine_real_disable (IBusEngine* base)
{
	KkcEngine * self;
	guint _tmp0_;
	KkcContext* _tmp2_;
	KkcDictionaryList* _tmp3_;
	KkcDictionaryList* _tmp4_;
	self = (KkcEngine*) base;
	g_signal_emit_by_name ((IBusEngine*) self, "focus-out");
	_tmp0_ = self->priv->save_dictionaries_timeout_id;
	if (_tmp0_ > ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = self->priv->save_dictionaries_timeout_id;
		g_source_remove (_tmp1_);
		self->priv->save_dictionaries_timeout_id = (guint) 0;
	}
	_tmp2_ = self->priv->context;
	_tmp3_ = kkc_context_get_dictionaries (_tmp2_);
	_tmp4_ = _tmp3_;
	kkc_dictionary_list_save (_tmp4_);
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->disable (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
}


static void
kkc_engine_real_reset (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	IBusText* empty_text = NULL;
	IBusText* _tmp1_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	kkc_context_reset (_tmp0_);
	_tmp1_ = ibus_text_new_from_static_string ("");
	g_object_ref_sink (_tmp1_);
	empty_text = _tmp1_;
	ibus_engine_update_preedit_text ((IBusEngine*) self, empty_text, (guint) 0, FALSE);
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->reset (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
	_g_object_unref0 (empty_text);
}


static void
kkc_engine_real_focus_in (IBusEngine* base)
{
	KkcEngine * self;
	IBusPropList* _tmp0_;
	self = (KkcEngine*) base;
	kkc_engine_update_input_mode (self);
	_tmp0_ = self->priv->prop_list;
	ibus_engine_register_properties ((IBusEngine*) self, _tmp0_);
	self->priv->properties_registered = TRUE;
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->focus_in (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
}


static void
kkc_engine_real_focus_out (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	kkc_context_reset (_tmp0_);
	ibus_engine_hide_preedit_text ((IBusEngine*) self);
	ibus_engine_hide_lookup_table ((IBusEngine*) self);
	self->priv->properties_registered = FALSE;
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->focus_out (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
}


static void
kkc_engine_real_property_activate (IBusEngine* base,
                                   const gchar* prop_name,
                                   guint prop_state)
{
	KkcEngine * self;
	GError * _inner_error_ = NULL;
	self = (KkcEngine*) base;
	g_return_if_fail (prop_name != NULL);
	if (g_strcmp0 (prop_name, "setup") == 0) {
		gchar* filename = NULL;
		gchar* _tmp0_;
		_tmp0_ = g_build_filename (LIBEXECDIR, "ibus-setup-kkc", NULL);
		filename = _tmp0_;
		{
			const gchar* _tmp1_;
			_tmp1_ = filename;
			g_spawn_command_line_async (_tmp1_, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_SPAWN_ERROR) {
					goto __catch3_g_spawn_error;
				}
				_g_free0 (filename);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		goto __finally3;
		__catch3_g_spawn_error:
		{
			GError* e = NULL;
			const gchar* _tmp2_;
			GError* _tmp3_;
			const gchar* _tmp4_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp2_ = filename;
			_tmp3_ = e;
			_tmp4_ = _tmp3_->message;
			g_warning ("engine.vala:597: can't spawn %s: %s", _tmp2_, _tmp4_);
			_g_error_free0 (e);
		}
		__finally3:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (filename);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_g_free0 (filename);
	} else {
		gboolean _tmp5_ = FALSE;
		if (g_str_has_prefix (prop_name, "InputMode.")) {
			_tmp5_ = prop_state == ((guint) PROP_STATE_CHECKED);
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			KkcContext* _tmp6_;
			GeeMap* _tmp7_;
			gpointer _tmp8_;
			_tmp6_ = self->priv->context;
			_tmp7_ = self->priv->name_input_modes;
			_tmp8_ = gee_map_get (_tmp7_, prop_name);
			kkc_context_set_input_mode (_tmp6_, (KkcInputMode) ((gintptr) _tmp8_));
		}
	}
}


static void
kkc_engine_real_candidate_clicked (IBusEngine* base,
                                   guint index,
                                   guint button,
                                   guint state)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
	_tmp2_ = _tmp1_;
	kkc_candidate_list_select_at (_tmp2_, index);
}


static void
kkc_engine_real_cursor_up (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
	_tmp2_ = _tmp1_;
	kkc_candidate_list_cursor_up (_tmp2_);
}


static void
kkc_engine_real_cursor_down (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
	_tmp2_ = _tmp1_;
	kkc_candidate_list_cursor_down (_tmp2_);
}


static void
kkc_engine_real_page_up (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
	_tmp2_ = _tmp1_;
	kkc_candidate_list_page_up (_tmp2_);
}


static void
kkc_engine_real_page_down (IBusEngine* base)
{
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
	_tmp2_ = _tmp1_;
	kkc_candidate_list_page_down (_tmp2_);
}


static void
__lambda5_ (void)
{
	ibus_quit ();
}


static void
___lambda5__ibus_bus_disconnected (IBusBus* _sender,
                                   gpointer self)
{
	__lambda5_ ();
}


static void
__lambda6_ (const gchar* name,
            GVariant* value)
{
	g_return_if_fail (name != NULL);
	g_return_if_fail (value != NULL);
	if (g_strcmp0 (name, "dictionaries") == 0) {
		kkc_engine_reload_dictionaries ();
	}
}


static void
___lambda6__preferences_value_changed (Preferences* _sender,
                                       const gchar* name,
                                       GVariant* value,
                                       gpointer self)
{
	__lambda6_ (name, value);
}


gint
kkc_engine_main (gchar** args,
                 int args_length1)
{
	gint result = 0;
	GOptionContext* context = NULL;
	GOptionContext* _tmp0_;
	GOptionContext* _tmp1_;
	IBusBus* bus = NULL;
	IBusBus* _tmp8_;
	IBusBus* _tmp9_;
	IBusBus* _tmp11_;
	IBusConfig* config = NULL;
	IBusBus* _tmp12_;
	IBusConfig* _tmp13_;
	IBusConfig* _tmp14_;
	IBusConfig* _tmp15_;
	IBusConfig* _tmp24_;
	Preferences* _tmp25_;
	GeeArrayList* _tmp26_;
	Preferences* _tmp27_;
	IBusFactory* factory = NULL;
	IBusBus* _tmp28_;
	GDBusConnection* _tmp29_;
	IBusFactory* _tmp30_;
	IBusFactory* _tmp31_;
	gboolean _tmp32_;
	GError * _inner_error_ = NULL;
	ibus_init ();
	kkc_init ();
	gtk_init (&args_length1, &args);
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
	_tmp0_ = g_option_context_new ("- ibus kkc");
	context = _tmp0_;
	_tmp1_ = context;
	g_option_context_add_main_entries (_tmp1_, KKC_ENGINE_options, "ibus-kkc");
	{
		GOptionContext* _tmp2_;
		_tmp2_ = context;
		g_option_context_parse (_tmp2_, &args_length1, &args, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gint _tmp3_ = -1;
			if (_inner_error_->domain == G_OPTION_ERROR) {
				goto __catch4_g_option_error;
			}
			_g_option_context_free0 (context);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp3_;
		}
	}
	goto __finally4;
	__catch4_g_option_error:
	{
		GError* e = NULL;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = stderr;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		fprintf (_tmp4_, "%s\n", _tmp6_);
		result = 1;
		_g_error_free0 (e);
		_g_option_context_free0 (context);
		return result;
	}
	__finally4:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp7_ = -1;
		_g_option_context_free0 (context);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp7_;
	}
	_tmp8_ = ibus_bus_new ();
	g_object_ref_sink (_tmp8_);
	bus = _tmp8_;
	_tmp9_ = bus;
	if (!ibus_bus_is_connected (_tmp9_)) {
		FILE* _tmp10_;
		_tmp10_ = stderr;
		fprintf (_tmp10_, "cannot connect to ibus-daemon!\n");
		result = 1;
		_g_object_unref0 (bus);
		_g_option_context_free0 (context);
		return result;
	}
	_tmp11_ = bus;
	g_signal_connect (_tmp11_, "disconnected", (GCallback) ___lambda5__ibus_bus_disconnected, NULL);
	_tmp12_ = bus;
	_tmp13_ = ibus_bus_get_config (_tmp12_);
	_tmp14_ = _g_object_ref0 (_tmp13_);
	config = _tmp14_;
	_tmp15_ = config;
	if (_tmp15_ == NULL) {
		FILE* _tmp16_;
		_tmp16_ = stderr;
		fprintf (_tmp16_, "ibus-config component is not running!\n");
		result = 1;
		_g_object_unref0 (config);
		_g_object_unref0 (bus);
		_g_option_context_free0 (context);
		return result;
	}
	{
		KkcLanguageModel* _tmp17_ = NULL;
		KkcLanguageModel* _tmp18_;
		KkcLanguageModel* _tmp19_;
		_tmp18_ = kkc_language_model_load ("sorted3", &_inner_error_);
		_tmp17_ = _tmp18_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch5_g_error;
		}
		_tmp19_ = _tmp17_;
		_tmp17_ = NULL;
		_g_object_unref0 (kkc_engine_language_model);
		kkc_engine_language_model = _tmp19_;
		_g_object_unref0 (_tmp17_);
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		FILE* _tmp20_;
		GError* _tmp21_;
		const gchar* _tmp22_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp20_ = stderr;
		_tmp21_ = e;
		_tmp22_ = _tmp21_->message;
		fprintf (_tmp20_, "can't load language model: %s\n", _tmp22_);
		result = 1;
		_g_error_free0 (e);
		_g_object_unref0 (config);
		_g_object_unref0 (bus);
		_g_option_context_free0 (context);
		return result;
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp23_ = -1;
		_g_object_unref0 (config);
		_g_object_unref0 (bus);
		_g_option_context_free0 (context);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp23_;
	}
	_tmp24_ = config;
	_tmp25_ = preferences_new (_tmp24_);
	_g_object_unref0 (kkc_engine_preferences);
	kkc_engine_preferences = _tmp25_;
	_tmp26_ = gee_array_list_new (KKC_TYPE_DICTIONARY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (kkc_engine_dictionaries);
	kkc_engine_dictionaries = _tmp26_;
	kkc_engine_reload_dictionaries ();
	_tmp27_ = kkc_engine_preferences;
	g_signal_connect (_tmp27_, "value-changed", (GCallback) ___lambda6__preferences_value_changed, NULL);
	_tmp28_ = bus;
	_tmp29_ = ibus_bus_get_connection (_tmp28_);
	_tmp30_ = ibus_factory_new (_tmp29_);
	g_object_ref_sink (_tmp30_);
	factory = _tmp30_;
	_tmp31_ = factory;
	ibus_factory_add_engine (_tmp31_, "kkc", TYPE_KKC_ENGINE);
	_tmp32_ = kkc_engine_ibus;
	if (_tmp32_) {
		IBusBus* _tmp33_;
		_tmp33_ = bus;
		ibus_bus_request_name (_tmp33_, "org.freedesktop.IBus.KKC", (guint32) 0);
	} else {
		IBusComponent* component = NULL;
		IBusComponent* _tmp34_;
		IBusEngineDesc* engine = NULL;
		gchar* _tmp35_;
		gchar* _tmp36_;
		IBusEngineDesc* _tmp37_;
		IBusEngineDesc* _tmp38_;
		IBusComponent* _tmp39_;
		IBusEngineDesc* _tmp40_;
		IBusBus* _tmp41_;
		IBusComponent* _tmp42_;
		_tmp34_ = ibus_component_new ("org.freedesktop.IBus.KKC", N_ ("Kana Kanji"), PACKAGE_VERSION, "GPL", "Daiki Ueno <ueno@gnu.org>", "https://github.com/ueno/ibus-kkc", "", "ibus-kkc");
		g_object_ref_sink (_tmp34_);
		component = _tmp34_;
		_tmp35_ = g_strdup_printf ("%s/icons/ibus-kkc.svg", PACKAGE_DATADIR);
		_tmp36_ = _tmp35_;
		_tmp37_ = ibus_engine_desc_new ("kkc", "Kana Kanji", "Kana Kanji Input Method", "ja", "GPL", "Daiki Ueno <ueno@gnu.org>", _tmp36_, "us");
		g_object_ref_sink (_tmp37_);
		_tmp38_ = _tmp37_;
		_g_free0 (_tmp36_);
		engine = _tmp38_;
		_tmp39_ = component;
		_tmp40_ = engine;
		ibus_component_add_engine (_tmp39_, _tmp40_);
		_tmp41_ = bus;
		_tmp42_ = component;
		ibus_bus_register_component (_tmp41_, _tmp42_);
		_g_object_unref0 (engine);
		_g_object_unref0 (component);
	}
	ibus_main ();
	result = 0;
	_g_object_unref0 (factory);
	_g_object_unref0 (config);
	_g_object_unref0 (bus);
	_g_option_context_free0 (context);
	return result;
}


int
main (int argc,
      char ** argv)
{
	return kkc_engine_main (argv, argc);
}


KkcEngine*
kkc_engine_construct (GType object_type)
{
	KkcEngine * self = NULL;
	self = (KkcEngine*) g_object_new (object_type, NULL);
	return self;
}


KkcEngine*
kkc_engine_new (void)
{
	return kkc_engine_construct (TYPE_KKC_ENGINE);
}


static void
_kkc_engine___lambda7_ (KkcEngine* self,
                        const gchar* name,
                        GVariant* value)
{
	g_return_if_fail (name != NULL);
	g_return_if_fail (value != NULL);
	kkc_engine_apply_preferences (self);
	if (g_strcmp0 (name, "dictionaries") == 0) {
		KkcContext* _tmp0_;
		KkcDictionaryList* _tmp1_;
		KkcDictionaryList* _tmp2_;
		_tmp0_ = self->priv->context;
		_tmp1_ = kkc_context_get_dictionaries (_tmp0_);
		_tmp2_ = _tmp1_;
		kkc_dictionary_list_clear (_tmp2_);
		{
			GeeArrayList* _dictionary_list = NULL;
			GeeArrayList* _tmp3_;
			GeeArrayList* _tmp4_;
			gint _dictionary_size = 0;
			GeeArrayList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _dictionary_index = 0;
			_tmp3_ = kkc_engine_dictionaries;
			_tmp4_ = _g_object_ref0 (_tmp3_);
			_dictionary_list = _tmp4_;
			_tmp5_ = _dictionary_list;
			_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
			_tmp7_ = _tmp6_;
			_dictionary_size = _tmp7_;
			_dictionary_index = -1;
			while (TRUE) {
				gint _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				KkcDictionary* dictionary = NULL;
				GeeArrayList* _tmp11_;
				gint _tmp12_;
				gpointer _tmp13_;
				KkcContext* _tmp14_;
				KkcDictionaryList* _tmp15_;
				KkcDictionaryList* _tmp16_;
				KkcDictionary* _tmp17_;
				_tmp8_ = _dictionary_index;
				_dictionary_index = _tmp8_ + 1;
				_tmp9_ = _dictionary_index;
				_tmp10_ = _dictionary_size;
				if (!(_tmp9_ < _tmp10_)) {
					break;
				}
				_tmp11_ = _dictionary_list;
				_tmp12_ = _dictionary_index;
				_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _tmp12_);
				dictionary = (KkcDictionary*) _tmp13_;
				_tmp14_ = self->priv->context;
				_tmp15_ = kkc_context_get_dictionaries (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = dictionary;
				kkc_dictionary_list_add (_tmp16_, _tmp17_);
				_g_object_unref0 (dictionary);
			}
			_g_object_unref0 (_dictionary_list);
		}
	}
}


static void
__kkc_engine___lambda7__preferences_value_changed (Preferences* _sender,
                                                   const gchar* name,
                                                   GVariant* value,
                                                   gpointer self)
{
	_kkc_engine___lambda7_ ((KkcEngine*) self, name, value);
}


static void
_kkc_engine___lambda8_ (KkcEngine* self)
{
	kkc_engine_update_preedit (self);
}


static void
__kkc_engine___lambda8__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self)
{
	_kkc_engine___lambda8_ ((KkcEngine*) self);
}


static void
_kkc_engine___lambda9_ (KkcEngine* self,
                        GObject* s,
                        GParamSpec* p)
{
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	kkc_engine_update_input_mode (self);
}


static void
__kkc_engine___lambda9__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self)
{
	_kkc_engine___lambda9_ ((KkcEngine*) self, _sender, pspec);
}


static void
_kkc_engine___lambda10_ (KkcEngine* self)
{
	kkc_engine_populate_lookup_table (self);
}


static void
__kkc_engine___lambda10__kkc_candidate_list_populated (KkcCandidateList* _sender,
                                                       gpointer self)
{
	_kkc_engine___lambda10_ ((KkcEngine*) self);
}


static void
_kkc_engine___lambda11_ (KkcEngine* self)
{
	kkc_engine_set_lookup_table_cursor_pos (self);
}


static void
__kkc_engine___lambda11__g_object_notify (GObject* _sender,
                                          GParamSpec* pspec,
                                          gpointer self)
{
	_kkc_engine___lambda11_ ((KkcEngine*) self);
}


static void
_kkc_engine___lambda12_ (KkcEngine* self)
{
	gboolean _tmp0_;
	_tmp0_ = self->priv->lookup_table_visible;
	if (_tmp0_) {
		ibus_engine_hide_lookup_table ((IBusEngine*) self);
		ibus_engine_hide_auxiliary_text ((IBusEngine*) self);
		self->priv->lookup_table_visible = FALSE;
	}
}


static void
__kkc_engine___lambda12__kkc_candidate_list_selected (KkcCandidateList* _sender,
                                                      KkcCandidate* candidate,
                                                      gpointer self)
{
	_kkc_engine___lambda12_ ((KkcEngine*) self);
}


static void
_kkc_engine___lambda13_ (KkcEngine* self,
                         KkcContext* e)
{
	GtkClipboard* _tmp0_;
	g_return_if_fail (e != NULL);
	_tmp0_ = self->priv->clipboard;
	gtk_clipboard_request_text (_tmp0_, (GtkClipboardTextReceivedFunc) kkc_engine_set_selection_text, self);
}


static void
__kkc_engine___lambda13__kkc_context_request_selection_text (KkcContext* _sender,
                                                             gpointer self)
{
	_kkc_engine___lambda13_ ((KkcEngine*) self, _sender);
}


static GObject *
kkc_engine_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	KkcEngine * self;
	IBusLookupTable* _tmp0_;
	IBusPropList* _tmp10_;
	IBusPropList* props = NULL;
	IBusPropList* _tmp11_;
	IBusProperty* prop = NULL;
	IBusProperty* _tmp12_;
	IBusPropList* _tmp13_;
	IBusProperty* _tmp14_;
	IBusProperty* _tmp15_;
	IBusPropList* _tmp16_;
	IBusProperty* _tmp17_;
	IBusProperty* _tmp18_;
	IBusPropList* _tmp19_;
	IBusProperty* _tmp20_;
	IBusProperty* _tmp21_;
	IBusPropList* _tmp22_;
	IBusProperty* _tmp23_;
	IBusProperty* _tmp24_;
	IBusPropList* _tmp25_;
	IBusProperty* _tmp26_;
	IBusProperty* _tmp27_;
	IBusPropList* _tmp28_;
	IBusProperty* _tmp29_;
	IBusText* _tmp30_;
	IBusText* _tmp31_;
	IBusText* _tmp32_;
	IBusText* _tmp33_;
	IBusPropList* _tmp34_;
	IBusProperty* _tmp35_;
	IBusPropList* _tmp36_;
	IBusProperty* _tmp37_;
	IBusProperty* _tmp38_;
	IBusProperty* _tmp39_;
	IBusText* _tmp40_;
	IBusText* _tmp41_;
	IBusText* _tmp42_;
	IBusText* _tmp43_;
	IBusProperty* _tmp44_;
	IBusPropList* _tmp45_;
	IBusProperty* _tmp46_;
	KkcLanguageModel* _tmp47_;
	KkcContext* _tmp48_;
	Preferences* _tmp64_;
	KkcContext* _tmp65_;
	KkcContext* _tmp66_;
	KkcContext* _tmp67_;
	KkcCandidateList* _tmp68_;
	KkcCandidateList* _tmp69_;
	KkcContext* _tmp70_;
	KkcCandidateList* _tmp71_;
	KkcCandidateList* _tmp72_;
	KkcContext* _tmp73_;
	KkcCandidateList* _tmp74_;
	KkcCandidateList* _tmp75_;
	GtkClipboard* _tmp76_;
	GtkClipboard* _tmp77_;
	KkcContext* _tmp78_;
	parent_class = G_OBJECT_CLASS (kkc_engine_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_KKC_ENGINE, KkcEngine);
	_tmp0_ = ibus_lookup_table_new ((guint) G_N_ELEMENTS (KKC_ENGINE_LOOKUP_TABLE_LABELS), (guint) 0, TRUE, TRUE);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->lookup_table);
	self->priv->lookup_table = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				IBusText* text = NULL;
				gint _tmp4_;
				const gchar* _tmp5_;
				IBusText* _tmp6_;
				IBusLookupTable* _tmp7_;
				gint _tmp8_;
				IBusText* _tmp9_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = i;
				if (!(_tmp3_ < G_N_ELEMENTS (KKC_ENGINE_LOOKUP_TABLE_LABELS))) {
					break;
				}
				_tmp4_ = i;
				_tmp5_ = KKC_ENGINE_LOOKUP_TABLE_LABELS[_tmp4_];
				_tmp6_ = ibus_text_new_from_string (_tmp5_);
				g_object_ref_sink (_tmp6_);
				text = _tmp6_;
				_tmp7_ = self->priv->lookup_table;
				_tmp8_ = i;
				_tmp9_ = text;
				ibus_lookup_table_set_label (_tmp7_, (guint) _tmp8_, _tmp9_);
				_g_object_unref0 (text);
			}
		}
	}
	_tmp10_ = ibus_prop_list_new ();
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->prop_list);
	self->priv->prop_list = _tmp10_;
	_tmp11_ = ibus_prop_list_new ();
	g_object_ref_sink (_tmp11_);
	props = _tmp11_;
	_tmp12_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_HIRAGANA, "InputMode.Hiragana", _ ("Hiragana"), "あ");
	_g_object_unref0 (prop);
	prop = _tmp12_;
	_tmp13_ = props;
	_tmp14_ = prop;
	ibus_prop_list_append (_tmp13_, _tmp14_);
	_tmp15_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_KATAKANA, "InputMode.Katakana", _ ("Katakana"), "ア");
	_g_object_unref0 (prop);
	prop = _tmp15_;
	_tmp16_ = props;
	_tmp17_ = prop;
	ibus_prop_list_append (_tmp16_, _tmp17_);
	_tmp18_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_HANKAKU_KATAKANA, "InputMode.HankakuKatakana", _ ("Halfwidth Katakana"), "_ｱ");
	_g_object_unref0 (prop);
	prop = _tmp18_;
	_tmp19_ = props;
	_tmp20_ = prop;
	ibus_prop_list_append (_tmp19_, _tmp20_);
	_tmp21_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_LATIN, "InputMode.Latin", _ ("Latin"), "_A");
	_g_object_unref0 (prop);
	prop = _tmp21_;
	_tmp22_ = props;
	_tmp23_ = prop;
	ibus_prop_list_append (_tmp22_, _tmp23_);
	_tmp24_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_WIDE_LATIN, "InputMode.WideLatin", _ ("Wide Latin"), "Ａ");
	_g_object_unref0 (prop);
	prop = _tmp24_;
	_tmp25_ = props;
	_tmp26_ = prop;
	ibus_prop_list_append (_tmp25_, _tmp26_);
	_tmp27_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_DIRECT, "InputMode.Direct", _ ("Direct Input"), "_A");
	_g_object_unref0 (prop);
	prop = _tmp27_;
	_tmp28_ = props;
	_tmp29_ = prop;
	ibus_prop_list_append (_tmp28_, _tmp29_);
	_tmp30_ = ibus_text_new_from_string ("あ");
	g_object_ref_sink (_tmp30_);
	_tmp31_ = _tmp30_;
	_tmp32_ = ibus_text_new_from_string (_ ("Switch input mode"));
	g_object_ref_sink (_tmp32_);
	_tmp33_ = _tmp32_;
	_tmp34_ = props;
	_tmp35_ = ibus_property_new ("InputMode", PROP_TYPE_MENU, _tmp31_, NULL, _tmp33_, TRUE, TRUE, PROP_STATE_UNCHECKED, _tmp34_);
	g_object_ref_sink (_tmp35_);
	_g_object_unref0 (prop);
	prop = _tmp35_;
	_g_object_unref0 (_tmp33_);
	_g_object_unref0 (_tmp31_);
	_tmp36_ = self->priv->prop_list;
	_tmp37_ = prop;
	ibus_prop_list_append (_tmp36_, _tmp37_);
	_tmp38_ = prop;
	_tmp39_ = _g_object_ref0 (_tmp38_);
	_g_object_unref0 (self->priv->input_mode_prop);
	self->priv->input_mode_prop = _tmp39_;
	_tmp40_ = ibus_text_new_from_string (_ ("Preferences"));
	g_object_ref_sink (_tmp40_);
	_tmp41_ = _tmp40_;
	_tmp42_ = ibus_text_new_from_string (_ ("Configure Kana Kanji Conversion"));
	g_object_ref_sink (_tmp42_);
	_tmp43_ = _tmp42_;
	_tmp44_ = ibus_property_new ("setup", PROP_TYPE_NORMAL, _tmp41_, "gtk-preferences", _tmp43_, TRUE, TRUE, PROP_STATE_UNCHECKED, NULL);
	g_object_ref_sink (_tmp44_);
	_g_object_unref0 (prop);
	prop = _tmp44_;
	_g_object_unref0 (_tmp43_);
	_g_object_unref0 (_tmp41_);
	_tmp45_ = self->priv->prop_list;
	_tmp46_ = prop;
	ibus_prop_list_append (_tmp45_, _tmp46_);
	_tmp47_ = kkc_engine_language_model;
	_tmp48_ = kkc_context_new (_tmp47_);
	_g_object_unref0 (self->priv->context);
	self->priv->context = _tmp48_;
	{
		GeeArrayList* _dictionary_list = NULL;
		GeeArrayList* _tmp49_;
		GeeArrayList* _tmp50_;
		gint _dictionary_size = 0;
		GeeArrayList* _tmp51_;
		gint _tmp52_;
		gint _tmp53_;
		gint _dictionary_index = 0;
		_tmp49_ = kkc_engine_dictionaries;
		_tmp50_ = _g_object_ref0 (_tmp49_);
		_dictionary_list = _tmp50_;
		_tmp51_ = _dictionary_list;
		_tmp52_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp51_);
		_tmp53_ = _tmp52_;
		_dictionary_size = _tmp53_;
		_dictionary_index = -1;
		while (TRUE) {
			gint _tmp54_;
			gint _tmp55_;
			gint _tmp56_;
			KkcDictionary* dictionary = NULL;
			GeeArrayList* _tmp57_;
			gint _tmp58_;
			gpointer _tmp59_;
			KkcContext* _tmp60_;
			KkcDictionaryList* _tmp61_;
			KkcDictionaryList* _tmp62_;
			KkcDictionary* _tmp63_;
			_tmp54_ = _dictionary_index;
			_dictionary_index = _tmp54_ + 1;
			_tmp55_ = _dictionary_index;
			_tmp56_ = _dictionary_size;
			if (!(_tmp55_ < _tmp56_)) {
				break;
			}
			_tmp57_ = _dictionary_list;
			_tmp58_ = _dictionary_index;
			_tmp59_ = gee_abstract_list_get ((GeeAbstractList*) _tmp57_, _tmp58_);
			dictionary = (KkcDictionary*) _tmp59_;
			_tmp60_ = self->priv->context;
			_tmp61_ = kkc_context_get_dictionaries (_tmp60_);
			_tmp62_ = _tmp61_;
			_tmp63_ = dictionary;
			kkc_dictionary_list_add (_tmp62_, _tmp63_);
			_g_object_unref0 (dictionary);
		}
		_g_object_unref0 (_dictionary_list);
	}
	kkc_engine_apply_preferences (self);
	_tmp64_ = kkc_engine_preferences;
	g_signal_connect_object (_tmp64_, "value-changed", (GCallback) __kkc_engine___lambda7__preferences_value_changed, self, 0);
	_tmp65_ = self->priv->context;
	g_signal_connect_object ((GObject*) _tmp65_, "notify::input", (GCallback) __kkc_engine___lambda8__g_object_notify, self, 0);
	_tmp66_ = self->priv->context;
	g_signal_connect_object ((GObject*) _tmp66_, "notify::input-mode", (GCallback) __kkc_engine___lambda9__g_object_notify, self, 0);
	_tmp67_ = self->priv->context;
	_tmp68_ = kkc_context_get_candidates (_tmp67_);
	_tmp69_ = _tmp68_;
	g_signal_connect_object (_tmp69_, "populated", (GCallback) __kkc_engine___lambda10__kkc_candidate_list_populated, self, 0);
	_tmp70_ = self->priv->context;
	_tmp71_ = kkc_context_get_candidates (_tmp70_);
	_tmp72_ = _tmp71_;
	g_signal_connect_object ((GObject*) _tmp72_, "notify::cursor-pos", (GCallback) __kkc_engine___lambda11__g_object_notify, self, 0);
	_tmp73_ = self->priv->context;
	_tmp74_ = kkc_context_get_candidates (_tmp73_);
	_tmp75_ = _tmp74_;
	g_signal_connect_object (_tmp75_, "selected", (GCallback) __kkc_engine___lambda12__kkc_candidate_list_selected, self, 0);
	_tmp76_ = gtk_clipboard_get (GDK_SELECTION_PRIMARY);
	_tmp77_ = _g_object_ref0 (_tmp76_);
	_g_object_unref0 (self->priv->clipboard);
	self->priv->clipboard = _tmp77_;
	_tmp78_ = self->priv->context;
	g_signal_connect_object (_tmp78_, "request-selection-text", (GCallback) __kkc_engine___lambda13__kkc_context_request_selection_text, self, 0);
	kkc_engine_update_candidates (self);
	kkc_engine_update_input_mode (self);
	_g_object_unref0 (prop);
	_g_object_unref0 (props);
	return obj;
}


static void
kkc_engine_class_init (KkcEngineClass * klass)
{
	kkc_engine_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &KkcEngine_private_offset);
	((IBusEngineClass *) klass)->process_key_event = (gboolean (*) (IBusEngine *, guint, guint, guint)) kkc_engine_real_process_key_event;
	((IBusEngineClass *) klass)->enable = (void (*) (IBusEngine *)) kkc_engine_real_enable;
	((IBusEngineClass *) klass)->disable = (void (*) (IBusEngine *)) kkc_engine_real_disable;
	((IBusEngineClass *) klass)->reset = (void (*) (IBusEngine *)) kkc_engine_real_reset;
	((IBusEngineClass *) klass)->focus_in = (void (*) (IBusEngine *)) kkc_engine_real_focus_in;
	((IBusEngineClass *) klass)->focus_out = (void (*) (IBusEngine *)) kkc_engine_real_focus_out;
	((IBusEngineClass *) klass)->property_activate = (void (*) (IBusEngine *, const gchar*, guint)) kkc_engine_real_property_activate;
	((IBusEngineClass *) klass)->candidate_clicked = (void (*) (IBusEngine *, guint, guint, guint)) kkc_engine_real_candidate_clicked;
	((IBusEngineClass *) klass)->cursor_up = (void (*) (IBusEngine *)) kkc_engine_real_cursor_up;
	((IBusEngineClass *) klass)->cursor_down = (void (*) (IBusEngine *)) kkc_engine_real_cursor_down;
	((IBusEngineClass *) klass)->page_up = (void (*) (IBusEngine *)) kkc_engine_real_page_up;
	((IBusEngineClass *) klass)->page_down = (void (*) (IBusEngine *)) kkc_engine_real_page_down;
	G_OBJECT_CLASS (klass)->constructor = kkc_engine_constructor;
	G_OBJECT_CLASS (klass)->finalize = kkc_engine_finalize;
}


static void
kkc_engine_instance_init (KkcEngine * self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	self->priv = kkc_engine_get_instance_private (self);
	self->priv->properties_registered = FALSE;
	_tmp0_ = gee_hash_map_new (KKC_TYPE_INPUT_MODE, NULL, NULL, IBUS_TYPE_PROPERTY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->input_mode_props = (GeeMap*) _tmp0_;
	_tmp1_ = gee_hash_map_new (KKC_TYPE_INPUT_MODE, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->input_mode_symbols = (GeeMap*) _tmp1_;
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, KKC_TYPE_INPUT_MODE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->name_input_modes = (GeeMap*) _tmp2_;
	self->priv->save_dictionaries_timeout_id = (guint) 0;
}


static void
kkc_engine_finalize (GObject * obj)
{
	KkcEngine * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_KKC_ENGINE, KkcEngine);
	_g_object_unref0 (self->priv->context);
	_g_object_unref0 (self->priv->lookup_table);
	_g_object_unref0 (self->priv->keymap);
	_g_object_unref0 (self->priv->input_mode_prop);
	_g_object_unref0 (self->priv->prop_list);
	_g_object_unref0 (self->priv->input_mode_props);
	_g_object_unref0 (self->priv->input_mode_symbols);
	_g_object_unref0 (self->priv->name_input_modes);
	_g_object_unref0 (self->priv->clipboard);
	G_OBJECT_CLASS (kkc_engine_parent_class)->finalize (obj);
}


GType
kkc_engine_get_type (void)
{
	static volatile gsize kkc_engine_type_id__volatile = 0;
	if (g_once_init_enter (&kkc_engine_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (KkcEngineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_engine_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcEngine), 0, (GInstanceInitFunc) kkc_engine_instance_init, NULL };
		GType kkc_engine_type_id;
		kkc_engine_type_id = g_type_register_static (IBUS_TYPE_ENGINE, "KkcEngine", &g_define_type_info, 0);
		KkcEngine_private_offset = g_type_add_instance_private (kkc_engine_type_id, sizeof (KkcEnginePrivate));
		g_once_init_leave (&kkc_engine_type_id__volatile, kkc_engine_type_id);
	}
	return kkc_engine_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



